<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-guestedit.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Edit guest's menu                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Menue fuer die Gaeste editieren                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Do we edit/delete/change main menus or sub menus?
$AND = "(`what` = '' OR `what` IS NULL)"; $subMenu = '';

if (isGetRequestParameterSet('sub')) {
	$AND = sprintf("`action`='%s' AND `what` IS NOT NULL", getRequestParameter('sub'));
	$subMenu = getRequestParameter('sub');
} // END - if

// List all menu points and make them editable
if ((isFormSent('edit')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Edit menu entries
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();

	$count = '0'; $OUT = '';
	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = SQL_QUERY_ESC("SELECT `title`, `action`, `what` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				$DATA = SQL_FETCHARRAY($result);

				// Prepapre content
				$DATA = array(
					'cnt'    => $count,
					'sel'    => $sel,
					'action' => adminAddMenuSelectionBox('guest', 'action', 'sel_action[' . $sel . ']', $DATA['action']),
					'what'   => adminAddMenuSelectionBox('guest', 'what'  , 'sel_what['   . $sel . ']', $DATA['what']),
					'menu'   => $DATA['title'],
				);

				// Load row template
				$OUT .= loadTemplate('admin_edit_guest_menu_row', true, $DATA);
			} else {
				// Entry not found
				$DATA = array(
					'sel' => $sel
				);
				$OUT .= loadTemplate('admin_menu_404_row', true, $DATA);
			}

			// Free result and switch color
			SQL_FREERESULT($result);
		} // END - if
	} // END - foreach

	$content['rows'] = $OUT;
	$content['cnt']  = $count;

	// Load template
	loadTemplate('admin_edit_guest_menu_form', false, $content);
} elseif ((isFormSent('delete')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Del menu entries with or without confirmation
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();

	$count = '0';
	$OUT = '';

	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = SQL_QUERY_ESC("SELECT `title` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				$DATA = SQL_FETCHARRAY($result);
				$DATA = array(
					'cnt'  => $count,
					'menu' => $DATA['title'],
					'sel'  => $sel,
				);
				$OUT .= loadTemplate('admin_delete_guest_menu_row', true, $DATA);
			} else {
				// Entry not found?
				$DATA = array(
					'sel' => $sel
				);
				$OUT .= loadTemplate('admin_menu_404_row', true, $DATA);
			}
			SQL_FREERESULT($result);
		} // END - if
	} // END - foreach
	$content['rows'] = $OUT;
	$content['cnt']  = $count;

	// Load template
	loadTemplate('admin_delete_guest_menu', false, $content);
} elseif ((isPostRequestParameterSet('status')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Change status (visible / locked)
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();

	// Load template
	$count = '0'; $OUT = '';
	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = SQL_QUERY_ESC("SELECT `title`, `visible`, `locked` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				$data = SQL_FETCHARRAY($result);
				$data = array(
					'cnt'     => $count,
					'menu'    => $data['title'],
					'sel'     => $sel,
					'visible' => addSelectionBox('yn', $data['visible'], 'visible', $sel),
					'locked'  => addSelectionBox('yn', $data['locked'] , 'locked' , $sel),
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_status_row', true, $data);
			} else {
				// Entry not found?
				$data = array(
					'sel' => $sel
				);
				$OUT .= loadTemplate('admin_menu_404_row', true, $data);
			}

			SQL_FREERESULT($result);
		} // END - if
	} // END - foreach
	$content['cnt']  = $count;
	$content['rows'] = $OUT;

	// Load template
	loadTemplate('admin_guest_menu_status', false, $content);
} elseif ((isFormSent()) && (!isDemoModeActive())) {
	// An action is done...
	adminProcessMenuEditForm('guest', $subMenu);
} else {
	// Handle weightning
	doAdminProcessMenuWeightning('guest');

	// By default list menus
	if (empty($subMenu)) {
		// List only main menus
		$result = SQL_QUERY("SELECT `id`,`action`,`what`,`title`,`sort` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE (`what`='' OR `what` IS NULL) ORDER BY `sort` ASC", __FILE__, __LINE__);
	} else {
		// List sub menus
		$result = SQL_QUERY_ESC("SELECT `id`,`action`,`what`,`title`,`sort` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `action`='%s' AND `what` != '' AND `what` IS NOT NULL ORDER BY `sort` ASC",
			array($subMenu), __FILE__, __LINE__);
	}

	// Do we have entries?
	if (!SQL_HASZERONUMS($result)) {
		// Set sub value
		$content['sub'] = $subMenu;

		// Init variables
		$count = '0';
		$OUT = '';

		// Process all menu entries
		while ($data = SQL_FETCHARRAY($result)) {
			$count++;
			if (($data['sort'] == '0') || (($data['sort'] == 1) && (!empty($subMenu)))) {
				// Is highest position
				$NAVI = '<a href="{%url=modules.php?module=admin&amp;what=guestedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']+1) . '&amp;fid=' . $data['sort'] . '%}">{--LOWER--}</a>';
			} elseif ($count == SQL_NUMROWS($result)) {
				// Is lowest position
				$NAVI = '<a href="{%url=modules.php?module=admin&amp;what=guestedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']-1) . '&amp;fid=' . $data['sort'] . '%}">{--HIGHER--}</a>';
			} elseif ($data['sort'] > 0) {
				// Anything else between highest and lowest
				$NAVI = '<a href="{%url=modules.php?module=admin&amp;what=guestedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']-1) . '&amp;fid=' . $data['sort'] . '%}">{--HIGHER--}</a>/<a href=\"{%url=modules.php?module=admin&amp;what=guestedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']+1) . '&amp;fid=' . $data['sort'] . '%}">{--LOWER--}</a>';
			}

			if (empty($data['action'])) $data['action'] = '&nbsp;';
			if (empty($data['what']))   $data['what']   = '&nbsp;';
			if (empty($data['title']))  $data['title']  = '&nbsp;';

			// Prepapre content
			$row = array(
				'id'     => $data['id'],
				'action' => $data['action'],
				'what'   => $data['what'],
				'title'  => $data['title'],
				'navi'   => $NAVI,
				'mode'   => 'guest'
			);

			// Load row template
			$OUT .= loadTemplate('admin_menu_overview_row', true, $row);
		} // END - while

		// Add rows
		$content['rows'] = $OUT;

		// Free memory
		SQL_FREERESULT($result);

		// Load template
		loadTemplate('admin_edit_guest_menu', false, $content);
	} else {
		// Menu entries are missing... (???)
		displayMessage('{--ADMIN_NO_MENUS_FOUND--}');
	}
}

// [EOF]
?>
