<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/19/2003 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-refbanner.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Manage all referal banner                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Banner fuer die Ref-Links verwalten         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Some sanity-check
if ((!isPostRequestParameterSet('url')) || (!isPostRequestParameterSet('alternate'))) {
	unsetPostRequestParameter('ok');
} // END - if

if (isFormSent()) {
	// Fix older calls from add-new-banner-form
	if (!isGetRequestParameterSet('mode')) setGetRequestParameter('mode', 'add');
	$sql = '';
	switch (getRequestParameter('mode')) {
		case 'add':
			// Check if banner is already added
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_refbanner` WHERE `url`='%s' LIMIT 1",
				array(postRequestParameter('url')), __FILE__, __LINE__);

			// Was the banner found?
			if (SQL_HASZERONUMS($result)) {
				// Add banner
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_refbanner` (`url`, `alternate`, `visible`)
VALUES ('%s','%s','%s')",
					array(
						postRequestParameter('url'),
						postRequestParameter('alternate'),
						postRequestParameter('visible')
					), __FILE__, __LINE__);
			} // END - if

			// Free memory
			SQL_FREERESULT($result);
			break;

		case 'edit': // Update banner
			foreach (postRequestParameter('sel') as $id => $sel) {
				// Secure id
				$id = bigintval($id);

				// Update entry
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_refbanner` SET `url`='%s', `alternate`='%s', `visible`='%s' WHERE `id`=%s LIMIT 1",
					array(
						postRequestParameter('url', $id),
						postRequestParameter('alternate', $id),
						postRequestParameter('visible'),
						$id
					), __FILE__, __LINE__);
			}
			break;
	} // END - switch

	// Check if we have saved (updated)
	if (!SQL_HASZEROAFFECTED()) {
		// Updated!
		$content = '{--SETTINGS_SAVED--}';
	} else {
		// Nothing has been updated
		$content = '<span class="notice">{--SETTINGS_NOT_SAVED--}</span>';
	}

	// Display message
	displayMessage($content);
} elseif ((ifPostContainsSelections()) && (isFormSent('edit'))) {
	// Edit banner
	$OUT = '';
	foreach (postRequestParameter('sel') as $id => $sel) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT `id`, `url`, `alternate`, `visible` FROM `{?_MYSQL_PREFIX?}_refbanner` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		$content = SQL_FETCHARRAY($result);
		SQL_FREERESULT($result);

		// Preapre data for the row
		$content['visible'] = addSelectionBox('yn', $content['visible'], 'visible');

		// Load row template and switch color
		$OUT .= loadTemplate('admin_edit_refbanner_row', true, $content);
	} // END - foreach

	// Load main template
	loadTemplate('admin_edit_refbanner', false, $OUT);
} else {
	if ((ifPostContainsSelections()) && (isFormSent('delete'))) {
		// Delete banner
		foreach (postRequestParameter('sel') as $id => $sel) {
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_refbanner` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		} // END - foreach
	} // END - if

	// Referal levels
	$result = SQL_QUERY('SELECT `id`, `url`, `alternate`, `visible`, `counter`, `clicks` FROM `{?_MYSQL_PREFIX?}_refbanner` ORDER BY `url` ASC', __FILE__, __LINE__);

	// Entries found?
	if (!SQL_HASZERONUMS($result)) {
		// Make referal banner editable and deletable
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			// Load row template and switch color
			$OUT .= loadTemplate('admin_list_refbanner_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Load main template
		loadTemplate('admin_list_refbanner', false, $OUT);
	} // END - if

	// Form for adding new referal levels
	loadTemplate('admin_add_refbanner');
}

// [EOF]
?>
